// Code generated by github.com/99designs/gqlgen, DO NOT EDIT.

package model

import (
	"fmt"
	"io"
	"strconv"

	"gitlab.com/talgat.s/belka-go/graph/scalar"
)

type Player interface {
	IsPlayer()
	GetID() string
	GetName() string
}

type BotPlayer struct {
	ID   string `json:"id"`
	Name string `json:"name"`
}

func (BotPlayer) IsPlayer()            {}
func (this BotPlayer) GetID() string   { return this.ID }
func (this BotPlayer) GetName() string { return this.Name }

type Card struct {
	Rank scalar.Rank `json:"rank"`
	Suit scalar.Suit `json:"suit"`
}

type Game struct {
	ID     string  `json:"id"`
	Teams  []*Team `json:"teams"`
	Winner *Team   `json:"winner,omitempty"`
}

type Hand struct {
	Player Player  `json:"player"`
	Cards  []*Card `json:"cards"`
}

type InputCard struct {
	Suit *scalar.Suit `json:"suit,omitempty"`
	Rank *scalar.Rank `json:"rank,omitempty"`
}

type Lap struct {
	ID string `json:"id"`
}

type Move struct {
	ID     string `json:"id"`
	Player Player `json:"player"`
	Card   *Card  `json:"card"`
}

type PlayerSuit struct {
	Player Player      `json:"player"`
	Suit   scalar.Suit `json:"suit"`
}

type Round struct {
	ID          string        `json:"id"`
	TeamsPoints []*TeamPoints `json:"teamsPoints"`
	Winner      *Team         `json:"winner,omitempty"`
}

type SuccessMessage struct {
	Success *bool `json:"success,omitempty"`
}

type Team struct {
	ID      string   `json:"id"`
	Players []Player `json:"players"`
}

type TeamPoints struct {
	Team   *Team         `json:"team"`
	Points scalar.Points `json:"points"`
}

type TeamScore struct {
	Team  *Team        `json:"team"`
	Score scalar.Score `json:"score"`
}

type Tokens struct {
	Access  string `json:"access"`
	Refresh string `json:"refresh"`
}

type User struct {
	ID       string `json:"id"`
	Email    string `json:"email"`
	Username string `json:"username"`
	Role     Role   `json:"role"`
}

type UserPlayer struct {
	ID   string `json:"id"`
	Name string `json:"name"`
}

func (UserPlayer) IsPlayer()            {}
func (this UserPlayer) GetID() string   { return this.ID }
func (this UserPlayer) GetName() string { return this.Name }

type UserWithToken struct {
	User   *User   `json:"user"`
	Tokens *Tokens `json:"tokens"`
}

type Role string

const (
	RoleAdmin Role = "Admin"
	RoleUser  Role = "User"
)

var AllRole = []Role{
	RoleAdmin,
	RoleUser,
}

func (e Role) IsValid() bool {
	switch e {
	case RoleAdmin, RoleUser:
		return true
	}
	return false
}

func (e Role) String() string {
	return string(e)
}

func (e *Role) UnmarshalGQL(v interface{}) error {
	str, ok := v.(string)
	if !ok {
		return fmt.Errorf("enums must be strings")
	}

	*e = Role(str)
	if !e.IsValid() {
		return fmt.Errorf("%s is not a valid Role", str)
	}
	return nil
}

func (e Role) MarshalGQL(w io.Writer) {
	fmt.Fprint(w, strconv.Quote(e.String()))
}
